searchData={"items":[{"type":"module","title":"AbsintheQueryAll","doc":"Documentation for `AbsintheQueryAll`.","ref":"AbsintheQueryAll.html"},{"type":"function","title":"AbsintheQueryAll.get_all_operations/2","doc":"Gets a complete list of all possible operations for the specified operation type (i.e. query, mutation, or subscription).","ref":"AbsintheQueryAll.html#get_all_operations/2"},{"type":"function","title":"Examples - AbsintheQueryAll.get_all_operations/2","doc":"iex> AbsintheQueryAll.get_all_operations(TestAbsintheSchema, :query)\n    [\n      :badTestQuery, :testQuery, :theNumberOneQuery\n    ]","ref":"AbsintheQueryAll.html#get_all_operations/2-examples"},{"type":"function","title":"AbsintheQueryAll.get_comprehensive_response/1","doc":"Runs a query for the specified operation, requesting every possible field in the response.","ref":"AbsintheQueryAll.html#get_comprehensive_response/1"},{"type":"function","title":"Examples - AbsintheQueryAll.get_comprehensive_response/1","doc":"iex> AbsintheQueryAll.get_comprehensive_response(%{\n    ...>   schema: TestAbsintheSchema,\n    ...>   operation_type: :query,\n    ...>   operation_name: :theNumberOneQuery,\n    ...> })\n    {:ok, %{data: %{\"theNumberOneQuery\" => 1}}}","ref":"AbsintheQueryAll.html#get_comprehensive_response/1-examples"},{"type":"module","title":"AbsintheQueryAll.Introspect","doc":"Code for getting a complete list of all of the data types in a GraphQL schema.","ref":"AbsintheQueryAll.Introspect.html"},{"type":"function","title":"AbsintheQueryAll.Introspect.get_all_types/2","doc":"Queries the provided GraphQL schema for every possible data type.","ref":"AbsintheQueryAll.Introspect.html#get_all_types/2"},{"type":"function","title":"Examples - AbsintheQueryAll.Introspect.get_all_types/2","doc":"iex> get_all_types(SomeGraphqlSchema)\n    [\n      %{name: :SomeGraphqlType, description: nil, fields: [...], ...},\n      %{name: :SomeOtherGraphqlType, description: nil, fields: [...], ...},\n      %{name: :SomeThirdGraphqlType, description: nil, fields: [...], ...}\n    ]","ref":"AbsintheQueryAll.Introspect.html#get_all_types/2-examples"},{"type":"module","title":"AbsintheQueryAll.Query","doc":"Code for generating a query string for a particular operation that requests every possible piece of data that is available in the response.","ref":"AbsintheQueryAll.Query.html"},{"type":"function","title":"AbsintheQueryAll.Query.comprehensive/1","doc":"Generates a query string that requests every possible field and subfield.","ref":"AbsintheQueryAll.Query.html#comprehensive/1"},{"type":"function","title":"Examples - AbsintheQueryAll.Query.comprehensive/1","doc":"iex> comprehensive(%{\n    ...>   operation_type: :query,\n    ...>   operation_name: :someQuery,\n    ...>   schema: SomeAbsintheSchema\n    ...> })\n    \"query someQuery {\n  someQuery { someField: someField someOtherField: someOtherField }\n}\n\"","ref":"AbsintheQueryAll.Query.html#comprehensive/1-examples"},{"type":"module","title":"AbsintheQueryAll.Query.Arguments","doc":"Code for generating ascertaining and stringifying the arguments to a specific operation.","ref":"AbsintheQueryAll.Query.Arguments.html"},{"type":"function","title":"AbsintheQueryAll.Query.Arguments.build_strings/2","doc":"","ref":"AbsintheQueryAll.Query.Arguments.html#build_strings/2"},{"type":"function","title":"AbsintheQueryAll.Query.Arguments.generate_for/2","doc":"","ref":"AbsintheQueryAll.Query.Arguments.html#generate_for/2"},{"type":"type","title":"AbsintheQueryAll.Query.Arguments.arg_data/0","doc":"","ref":"AbsintheQueryAll.Query.Arguments.html#t:arg_data/0"},{"type":"module","title":"AbsintheQueryAll.Query.Fields","doc":"Code for generating a query string for a specific field.","ref":"AbsintheQueryAll.Query.Fields.html"},{"type":"function","title":"AbsintheQueryAll.Query.Fields.generate_query_string/3","doc":"","ref":"AbsintheQueryAll.Query.Fields.html#generate_query_string/3"},{"type":"type","title":"AbsintheQueryAll.Query.Fields.field/0","doc":"","ref":"AbsintheQueryAll.Query.Fields.html#t:field/0"},{"type":"type","title":"AbsintheQueryAll.Query.Fields.permitted_fields/0","doc":"","ref":"AbsintheQueryAll.Query.Fields.html#t:permitted_fields/0"},{"type":"type","title":"AbsintheQueryAll.Query.Fields.scalar/0","doc":"","ref":"AbsintheQueryAll.Query.Fields.html#t:scalar/0"},{"type":"module","title":"AbsintheQueryAll.Query.Leaves","doc":"Code for generating a generating a query string representation of the leaves of a GraphQL request specification.","ref":"AbsintheQueryAll.Query.Leaves.html"},{"type":"function","title":"AbsintheQueryAll.Query.Leaves.query_string/3","doc":"","ref":"AbsintheQueryAll.Query.Leaves.html#query_string/3"},{"type":"module","title":"AbsintheQueryAll.Query.Operations","doc":"Functions for getting detailed information about the fields on a specific GraphQL operation.","ref":"AbsintheQueryAll.Query.Operations.html"},{"type":"function","title":"AbsintheQueryAll.Query.Operations.fields/2","doc":"","ref":"AbsintheQueryAll.Query.Operations.html#fields/2"},{"type":"function","title":"AbsintheQueryAll.Query.Operations.operation_field_type_name/2","doc":"","ref":"AbsintheQueryAll.Query.Operations.html#operation_field_type_name/2"},{"type":"type","title":"AbsintheQueryAll.Query.Operations.operation_type/0","doc":"","ref":"AbsintheQueryAll.Query.Operations.html#t:operation_type/0"},{"type":"module","title":"AbsintheQueryAll.Query.TypeLayers","doc":"Just the TypeLayers data type.","ref":"AbsintheQueryAll.Query.TypeLayers.html"},{"type":"type","title":"AbsintheQueryAll.Query.TypeLayers.type_layer/0","doc":"","ref":"AbsintheQueryAll.Query.TypeLayers.html#t:type_layer/0"},{"type":"module","title":"AbsintheQueryAll.Query.Types","doc":"Functions for getting detailed information about specific operations and the way their data is structured.","ref":"AbsintheQueryAll.Query.Types.html"},{"type":"function","title":"AbsintheQueryAll.Query.Types.details/2","doc":"","ref":"AbsintheQueryAll.Query.Types.html#details/2"},{"type":"function","title":"AbsintheQueryAll.Query.Types.fields_for/2","doc":"","ref":"AbsintheQueryAll.Query.Types.html#fields_for/2"},{"type":"function","title":"AbsintheQueryAll.Query.Types.for_operation/1","doc":"","ref":"AbsintheQueryAll.Query.Types.html#for_operation/1"},{"type":"function","title":"AbsintheQueryAll.Query.Types.get_by_name/2","doc":"","ref":"AbsintheQueryAll.Query.Types.html#get_by_name/2"},{"type":"type","title":"AbsintheQueryAll.Query.Types.data_structure/0","doc":"","ref":"AbsintheQueryAll.Query.Types.html#t:data_structure/0"},{"type":"type","title":"AbsintheQueryAll.Query.Types.details/0","doc":"","ref":"AbsintheQueryAll.Query.Types.html#t:details/0"},{"type":"type","title":"AbsintheQueryAll.Query.Types.enum_value/0","doc":"","ref":"AbsintheQueryAll.Query.Types.html#t:enum_value/0"},{"type":"type","title":"AbsintheQueryAll.Query.Types.type_data/0","doc":"","ref":"AbsintheQueryAll.Query.Types.html#t:type_data/0"},{"type":"module","title":"AbsintheQueryAll.Utils.Atom","doc":"Utilities for use with atoms.","ref":"AbsintheQueryAll.Utils.Atom.html"},{"type":"function","title":"AbsintheQueryAll.Utils.Atom.camelize/1","doc":"","ref":"AbsintheQueryAll.Utils.Atom.html#camelize/1"},{"type":"function","title":"AbsintheQueryAll.Utils.Atom.decapitalize/1","doc":"","ref":"AbsintheQueryAll.Utils.Atom.html#decapitalize/1"},{"type":"function","title":"AbsintheQueryAll.Utils.Atom.lower_camelize/1","doc":"","ref":"AbsintheQueryAll.Utils.Atom.html#lower_camelize/1"},{"type":"module","title":"AbsintheQueryAll.Utils.MapList","doc":"Utilities for use with lists of maps.","ref":"AbsintheQueryAll.Utils.MapList.html"},{"type":"function","title":"AbsintheQueryAll.Utils.MapList.get_by_name/2","doc":"","ref":"AbsintheQueryAll.Utils.MapList.html#get_by_name/2"},{"type":"module","title":"AbsintheQueryAll.Utils.Maybe","doc":"A \"maybe\" is a value that can be either some value or nil. Essentially this:\n\n    any() | nil\n\nThe concept is borrowed from Elm:\nhttps://package.elm-lang.org/packages/elm/core/latest/Maybe\n\nThis module is for chaining or otherwise manipulating\nmaybe values.","ref":"AbsintheQueryAll.Utils.Maybe.html"},{"type":"function","title":"AbsintheQueryAll.Utils.Maybe.map/2","doc":"","ref":"AbsintheQueryAll.Utils.Maybe.html#map/2"},{"type":"function","title":"AbsintheQueryAll.Utils.Maybe.with_default/2","doc":"","ref":"AbsintheQueryAll.Utils.Maybe.html#with_default/2"},{"type":"module","title":"AbsintheQueryAll.Utils.Report","doc":"Utilities for reporting issues with how the functions of this library are being called.","ref":"AbsintheQueryAll.Utils.Report.html"},{"type":"function","title":"AbsintheQueryAll.Utils.Report.wrong_arity/3","doc":"","ref":"AbsintheQueryAll.Utils.Report.html#wrong_arity/3"},{"type":"module","title":"AbsintheQueryAll.Utils.String","doc":"Utilities for use with strings.","ref":"AbsintheQueryAll.Utils.String.html"},{"type":"function","title":"AbsintheQueryAll.Utils.String.camelize/1","doc":"","ref":"AbsintheQueryAll.Utils.String.html#camelize/1"},{"type":"function","title":"AbsintheQueryAll.Utils.String.decapitalize/1","doc":"","ref":"AbsintheQueryAll.Utils.String.html#decapitalize/1"},{"type":"function","title":"AbsintheQueryAll.Utils.String.lower_camelize/1","doc":"","ref":"AbsintheQueryAll.Utils.String.html#lower_camelize/1"},{"type":"extras","title":"Absinthe Query All","doc":"# Absinthe Query All\n\nAbsinthe Query All is a tool for comprehensively and automatically querying and testing your Absinthe GraphQL schema.\n\nYou can read the story of how the core functionality of this package was developed [here](https://www.neurodynamic.online/writing/frontend-to-backend-type-safety).","ref":"readme.html"},{"type":"extras","title":"Installation - Absinthe Query All","doc":"If [available in Hex](https://hex.pm/docs/publish), the package can be installed\nby adding `absinthe_query_all` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:absinthe_query_all, \"~> 0.5.0\"}\n  ]\nend\n```\n\nDocumentation can be generated with [ExDoc](https://github.com/elixir-lang/ex_doc)\nand published on [HexDocs](https://hexdocs.pm). Once published, the docs can\nbe found at  .","ref":"readme.html#installation"},{"type":"extras","title":"How to use - Absinthe Query All","doc":"This core AbsintheQueryAll module provides two utility functions.","ref":"readme.html#how-to-use"},{"type":"extras","title":"the `get_all_operations` function - Absinthe Query All","doc":"This function returns a list of every operation of the specified type (i.e. query or mutation) in your absinthe graphql schema.\n\n```elixir\nAbsintheQueryAll.get_all_operations(SomeAbsintheSchema, :query)\n[\n  :someQuery, :someOtherQuery, :someThirdQuery\n]\n```","ref":"readme.html#the-get_all_operations-function"},{"type":"extras","title":"the `get_comprehensive_response` function - Absinthe Query All","doc":"The `get_comprehensive_response` function runs the graphql operation specified, requesting a response that contains every possible field and subfield.\n\n```elixir\nAbsintheQueryAll.get_comprehensive_response(%{\n  schema: SomeAbsintheSchema,\n  operation_type: :query,\n  operation_name: :someOperation,\n})\n{:ok, %{data: %{\"someField\" => 1, \"someOtherField\" => 2, \"someThirdField\" => 3}}}\n```","ref":"readme.html#the-get_comprehensive_response-function"},{"type":"extras","title":"Automatic comprehensiveness checking of your absinthe `resolve` callbacks - Absinthe Query All","doc":"Why these two functions? So that you can set them up like this:\n\n```elixir\ndescribe \"SomeAbsintheSchema\" do\n  # First we get every single query available in the schema\n  for operation <- AbsintheQueryAll.get_all_operations(SomeAbsintheSchema, :query) do\n    # Then we create a test case\n    test \"query `#{operation}` responds successfully\" do\n      # Inside the test case, we run the query\n      {status, response} = AbsintheQueryAll.get_comprehensive_response(%{\n        schema: TestAbsintheSchema,\n        operation_type: :query,\n        operation_name: unquote(Macro.escape(operation)),\n      })\n\n      # And then we check to see that it returned successfully\n      assert status == :ok\n      assert Map.has_key?(response, :data)\n      refute Map.has_key?(response, :errors)\n    end\n  end\n\n  # Then we do the same thing with our mutations\n  for operation <- AbsintheQueryAll.get_all_operations(SomeAbsintheSchema, :mutation) do\n    test \"mutation `#{operation}` responds successfully\" do\n      {status, response} = AbsintheQueryAll.get_comprehensive_response(%{\n        schema: TestAbsintheSchema,\n        operation_type: :mutation,\n        operation_name: unquote(Macro.escape(operation)),\n      })\n\n      assert status == :ok\n      assert Map.has_key?(response, :data)\n      refute Map.has_key?(response, :errors)\n    end\n  end\nend\n```\n\nWith that setup, your app will automatically generate a test for every single graphql operation and make sure that a response is being generated for every single field in that operation. Just a nice, simple extra layer protection against a specific type of bug.","ref":"readme.html#automatic-comprehensiveness-checking-of-your-absinthe-resolve-callbacks"},{"type":"extras","title":"Optional arguments to `AbsintheQueryAll.get_comprehensive_response` and `Query.comprehensive` - Absinthe Query All","doc":"#### Generating Argumentss\n\nYour schema likely has operations that require arguments. In order to generate arguments to pass to those operations, the `get_comprehensive_response` function has an optional argument, `argument_generator`, that you can pass an argument generating function to. The argument generating function should take two arguments: the first is the `operation_name` (e.g. `:someQuery`) and the second is the name of the argument you're generating (as an atom; e.g. `:userId`).\n\nFor example, you might call `get_comprehensive_response` like this:\n\n```elixir\nAbsintheQueryAll.get_comprehensive_response(%{\n  schema: SomeAbsintheSchema,\n  operation_type: :query,\n  operation_name: :testQuery,\n  argument_generator: fn operation_name, argument_name ->\n    case {operation_name, argument_name} do\n      {:someQuery, :theNameOfSomeStringArgumentsToTheQuery} ->\n        # if this argument requires a string, here's where you choose what string it gets\n        \"some string\"\n      {:someQuery, :theNameOfSomeIntegerArgumentsToTheQuery} ->\n        7\n\n    end \n})\n```\n\n#### Passing in Context\n\nThe optional `context` argument on `get_comprehensive_response` is just for passing along the `context` map that `Absinthe.run` takes. You might use this for something like passing in information on the currently logged in user if that has an effect on what your graphql endpoint will return for some operations.\n\n```elixir\nAbsintheQueryAll.get_comprehensive_response(%{\n  schema: SomeAbsintheSchema,\n  operation_type: :query,\n  operation_name: :testQuery,\n  context: %{current_user: user}\n})\n```\n\n#### Restricting fields in the response\n\nIf you would like a response that *does not* contain every possible field, you can pass the permitted_fields option to `get_comprehensive_response`. This option should be a map. It is a map instead of a list so that it can facilitate nesting of the permitted fields specification.\n\nFor example, the following code\n\n```elixir\nAbsintheQueryAll.get_comprehensive_response(%{\n  schema: SomeAbsintheSchema,\n  operation_type: :query,\n  operation_name: :testQuery,\n  permitted_fields: %{someField: nil, someOtherField: %{someNestedField: nil}}\n})\n\"query testQuery {\\n  testQuery { someField someOtherField { someNestedField } }\\n}\\n\"\n```\n\npresumes that `someOtherField` is an object with fields of its own, and will generate a query that only requests the `someField` and `someOtherField` fields at the top level, and only the `someNestedField` field inside the `someOtherField` object.\n\n#### Aliasing Options\n\nThe option to pass `parent_alias_generator` and `leaf_alias_generator` functions will most likely not be useful to most people, unless you, (A) specifically need to test something involving aliases, or (B) are using the utility functions available in this package to interface with tools like [elm-graphql](https://github.com/dillonkearns/elm-graphql) that automatically alias fields. But they are there if you need them.\n\n```elixir\niex> Query.comprehensive(%{\n...>   schema: SomeAbsintheSchema,\n...>   operation_type: :query,\n...>   operation_name: :testQuery,\n...>   parent_alias_generator: fn _field_name, _field_args -> \"someAlias\" end\n...> })\n\"query testQuery {\\n  someAlias: testQuery { someField }\\n}\\n\"\n```\n\n```elixir\niex> Query.comprehensive(%{\n...>   schema: SomeAbsintheSchema,\n...>   operation_type: :query,\n...>   operation_name: :testQuery,\n...>   leaf_alias_generator: fn field_name, _field_details -> \"#{field_name}Alias\" end\n...> })\n\"query testQuery {\\n  testQuery { someFieldAlias: someField }\\n}\\n\"\n```","ref":"readme.html#optional-arguments-to-absinthequeryall-get_comprehensive_response-and-query-comprehensive"},{"type":"extras","title":"Other possibilities - Absinthe Query All","doc":"This library intentionally exposes a lot of the underlying modules/functions that make the two main functions work, in case anyone wants to use them to build other tools. I use them for a variety of nice graphql testing functions that I may take a stab at generalizing and open-sourcing in the future if I find the time.","ref":"readme.html#other-possibilities"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}